; ---------------------------------------------------------------------------
;  Algo #5  to test and code to manage the display of the results.
;  Replace the "5" with the number of Algo you are inserting. 
; ---------------------------------------------------------------------------

.data
; ---------------------------------------------------------------------------
;  put here the description of your algo to test. max 30 chars.
; ---------------------------------------------------------------------------
; -------------------------<123456789012345678901234567890>------------------
    AlgoDesc5      byte    "Clive - reciprocal IMUL       ",0
; ---------------------------------------------------------------------------

.code

align 4

    mov  AlgoSize, (EndAlgo5  - Algo5 ) 

    jmp  Start5 

Algo5 :

align 4

AlgoN5  proc

; ----------------------------------------------------------------------
;  put here your code to test
; ----------------------------------------------------------------------

; EAX = 32-bit number
; ESI = string buffer for NUL terminated ASCII
; Uses ESI,EDI,EAX,ECX,EDX,EBX

    xor  ebx, ebx
    mov  ebx, 20
    lea  eax, NumToTest
    mov  PtrNumToTest, eax

ConvertNext5:

    lea  esi, NumFormat      ; Helps to initialize it every time round

    mov  eax, PtrNumToTest
    mov  eax, [eax]

    push    0

divloop5:

        mov     edx,04189374Ch       ; 2^40/1,000
        mov     ecx,eax              ; save the dividend
        mul     edx                  ; multiply to divide
        shr     edx,8                ; adjust the quotient
        imul    eax,edx,1000         ; find the product
        sub     ecx,eax              ; subtract the difference

        ; edx = quotient
        ; ecx = remainder

        mov     eax,ecx
        mov     edi,edx

        or      edi,edi
        jnz     digit0005

        cmp     eax,10
        jb      digit05

        cmp     eax,100
        jb      digit005

digit0005:

        mov     edx,0CCCCCCCDh       ; 2^35/10
        mov     ecx,eax              ; save the dividend
        mul     edx                  ; multiply to divide
        shr     edx,3                ; adjust the quotient
        imul    eax,edx,10           ; find the product
        sub     ecx,eax              ; subtract the difference

    ;edx = quotient
    ;ecx = remainder

        mov     eax,edx

        add     ecx,30h
        push    ecx

digit005:

        mov     edx,0CCCCCCCDh       ; 2^35/10
        mov     ecx,eax              ; save the dividend
        mul     edx                  ; multiply to divide
        shr     edx,3                ; adjust the quotient
        imul    eax,edx,10           ; find the product
        sub     ecx,eax              ; subtract the difference

    ;edx = quotient
    ;ecx = remainder

        mov     eax,edx

        add     ecx,30h
        push    ecx

digit05:

        add     eax,030h
        push    eax

        mov     eax,edi

        or      eax,eax
        jz      poploop5

        push    2Ch

        jmp     divloop5

poploop5:

        pop     eax
        mov     [esi],al
        inc     esi
        or      eax,eax
        jnz     poploop5

    add  PtrNumToTest, Four ; Next number to convert
    sub  ebx, One
    jnz  ConvertNext5

    ret

; ----------------------------------------------------------------------
;  end point of algo to test
; ----------------------------------------------------------------------

AlgoN5  endp 

EndAlgo5 :



Start5 :

ALIGN 4

    invoke AssignStr, addr AlgoDesc, offset AlgoDesc5 , 
                      dword ptr MaxLenStr


    invoke DisplayAt, dword ptr AlgoColDesc, dword ptr AlgoRow, addr AlgoDesc, 
                      dword ptr AlgoDescSize

    .if ( AlgoSize > 99 )

        sub  AlgoColSize, One

    .endif

    mov PtrAlgoSizeStr, ustrv$(AlgoSize, offset AlgoSizeStr)

    mov AlgoSizeStrLen, len(PtrAlgoSizeStr) 

    invoke DisplayAt, dword ptr AlgoColSize, dword ptr AlgoRow, addr AlgoSizeStr, 
                      dword ptr AlgoSizeStrLen 

    .if ( AlgoSize > 99 )

        add  AlgoColSize, One

    .endif

StartAlgo5 :

    invoke Sleep, 100
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS

; ------------------------------------------------------------------------------
;  algo to test is called here
; ------------------------------------------------------------------------------

    call AlgoN5 

; ------------------------------------------------------------------------------

    counter_end

    mov AlgoTicks, eax 

    mov PtrAlgoTicksStr, ustrv$(AlgoTicks, offset AlgoTicksStr)

    .if (AlgoTicks > 999)

       invoke FormatNum, PtrAlgoTicksStr;

       mov    StringLenght, len (PtrBufNum)

       .if  ( StringLenght < 9 )

            mov  eax, 9
            
            sub  eax, [StringLenght]

            add  AlgoColTicks, eax
            
       .endif 

       invoke DisplayAt, dword ptr AlgoColTicks, dword ptr AlgoRow, addr BufNum, 
                         dword ptr StringLenght

       jmp NextTest5   


    .endif

     

    invoke DisplayAt, dword ptr AlgoColTicks, dword ptr AlgoRow, addr AlgoTicksStr, 
                      sizeof AlgoTicksStr 



NextTest5 : 

    inc    TestDone

    mov    eax, TestToDo

    .if TestDone >= eax

        mov  TestDone, Zero

        jmp  EndTestAlgo5 

    .endif

    .if  ( StringLenght < 9 )

         mov  eax, 9
            
         sub  eax, [StringLenght]

         sub  AlgoColTicks, eax
            
    .endif 

    add AlgoColTicks, ColTicksDisplacement

    jmp StartAlgo5 

EndTestAlgo5 :

    mov AlgoColTicks, ColTicksInit

    add AlgoRow, Two

; ###########################################################################

